忘记密码   免费注册 查看新帖 |

ChinaUnix.net

  平台 论坛 博客 认证专区 大话IT 徽章 文库 自测 下载 频道自动化运维 虚拟化 储存备份 C/C++ PHP MySQL 嵌入式 Linux系统
最近访问板块 发新帖
查看: 1700 | 回复: 1

如何自定义一个异常并捕捉它?? [复制链接]

论坛徽章:
0
发表于 2018-01-27 11:17 |显示全部楼层
本帖最后由 zhsx616 于 2018-01-27 11:22 编辑

我想定义一个异常,这个异常是捕捉:当我输入一个数值,如果这个数值不在某个范围内,则触发这个异常。

以下是我的代码:
class Out_of_rangeError(Exception):
        pass
def catch_error(x):
        if x<0:
                raise Out_of_rangeError
while 1:
        try:
                a=raw_input('please input a number:')
                catch_error(a)
        except Out_of_rangeError:
                print 'the number you input is out of range\n'
        else:
                print 'the number is right.\n'

可是即使我输入-1,结果也是输出the number is right,也就是说,Out_of_rangeError异常没有被抛出,问题出在哪里??

论坛徽章:
1
15-16赛季CBA联赛之新疆
日期:2017-03-09 12:33:45
发表于 2018-01-29 12:52 |显示全部楼层
回复 1# zhsx616

因为raw_input得到的是字符串,而不是数字。你要得到数据,请用int(a)来得到
您需要登录后才可以回帖 登录 | 注册

本版积分规则

  

北京盛拓优讯信息技术有限公司. 版权所有 京ICP备16024965号 北京市公安局海淀分局网监中心备案编号:11010802020122
广播电视节目制作经营许可证(京) 字第1234号 中国互联网协会会员  联系我们:
感谢所有关心和支持过ChinaUnix的朋友们 转载本站内容请注明原作者名及出处

清除 Cookies - ChinaUnix - Archiver - WAP - TOP